<?php
$given_ip_address="0.0.0.0";
$country_name=$region_name="Not found";
$given_ip_address_array=array();

if ( isset( $_GET['ipv4'] ) ) {

      $given_ip_address = trim(addslashes($_GET['ipv4']));
      $given_ip_address_array = explode( ".", $given_ip_address );

      // check IP address format
      if ( is_numeric( $given_ip_address_array[0] ) && is_numeric( $given_ip_address_array[1] ) && is_numeric( $given_ip_address_array[2] ) && is_numeric( $given_ip_address_array[3] ) ){

          // declare database login details
          $db_host      = "localhost";              // Database host name
          $db_user      = "my_database_user";       // User for database authentication
          $db_pass      = "my_database_password";   // Password for database authentication
          $db_name      = "my_database";            // Database name
          $db_table     = "mytable_countryipranges";// Database table

          // see if we can connect
          mysql_connect($db_host,$db_user,$db_pass) or die('Could not connect: ' . mysql_error());
          mysql_select_db($db_name) or die('Could not connect: ' . mysql_error());

          // convert any padded values or non-numerical values
          foreach ($given_ip_address_array as &$value) $value*=1;

          // get the country and region based on given IP address
          $query = '
SELECT
    `CountryName`,
	`RegionIANA`,
	CONCAT(`IPRangeStart1`, \'.\', `IPRangeStart2`, \'.\', `IPRangeStart3`, \'.\', `IPRangeStart4`) AS IPRangeStart,
	CONCAT(`IPRangeEnd1`, \'.\', `IPRangeEnd2`, \'.\', `IPRangeEnd3`, \'.\', `IPRangeEnd4`) AS IPRangeEnd
FROM `'. $db_table.'`
WHERE
    (IPRangeStart1 <= '.$given_ip_address_array[0].' AND IPRangeEnd1 >= '.$given_ip_address_array[0].' )
    AND
    (IPRangeStart2 <= '.$given_ip_address_array[1].' AND IPRangeEnd2 >= '.$given_ip_address_array[1].' )
    AND
    (IPRangeStart3 <= '.$given_ip_address_array[2].' AND IPRangeEnd3 >= '.$given_ip_address_array[2].' )
    AND
    (IPRangeStart4 <= '.$given_ip_address_array[3].' AND IPRangeEnd4 >= '.$given_ip_address_array[3].' )
';
          $result = mysql_query(trim($query));
          if(mysql_num_rows($result) > 0) {
               $country_name=mysql_result($result,0,"CountryName");
               $region_name=mysql_result($result,0,"RegionIANA");

               $ip_range_start=mysql_result($result,0,"IPRangeStart");
               $ip_range_end=mysql_result($result,0,"IPRangeEnd");
          }

		  // if xml format specified then output xml
          if ( isset( $_GET['format'] ) && $_GET['format']=='xml' ) {
header("Content-type: text/xml");
echo '<?xml version="1.0" encoding="UTF-8"?>
<document>
    <project name="ip_lookup" default="build" basedir=".">
        <field name="ip_given" value="'.$given_ip_address_array[0].'.'.$given_ip_address_array[1].'.'.$given_ip_address_array[2].'.'.$given_ip_address_array[3].'" />
        <field name="ip_countryname" value="'.$country_name.'" />
        <field name="ip_ianaregion" value="'.$region_name.'" />
        <field name="ip_iprangestart" value="'.$ip_range_start.'" />
        <field name="ip_iprangeend" value="'.$ip_range_end.'" />
    </project>
    <source name="project_details">
        <field name="project_name" value="ip_lookup" />
        <field name="project_developer" value="Joel Lipman" />
        <field name="project_website" value="www.joellipman.com" />
        <field name="project_version_release_label" value="1.1" />
        <field name="project_version_release_year" value="'.date("Y").'" />
    </source>
</document>';
          } else {
	          if (( isset( $_GET['output'] ) && $_GET['output']=='country' && $_GET['format']!='xml' ) || ( !isset( $_GET['output'] ) && !isset( $_GET['format'] ) )){
	            echo $country_name;
	          }
	          if ( isset( $_GET['output'] ) && $_GET['output']=='iana_region' && $_GET['format']!='xml' ) {
	            echo $region_name;
	          }
		  }
      }


} else {
    echo '
    No IP Address given.<br />
    <br />Usage:
    <pre>
    ./ip_lookup.php?ipv4=123.123.123.123                      // returns country (no xml)
    ./ip_lookup.php?ipv4=123.123.123.123&format=xml           // returns xml with all details
    ./ip_lookup.php?ipv4=123.123.123.123&output=country       // returns country (no xml)
    ./ip_lookup.php?ipv4=123.123.123.123&output=iana_region   // returns IANA region (no xml)
    </pre>';
}
?>